=== modified file 'TODO'
--- TODO	2008-08-02 18:46:45 +0000
+++ TODO	2008-07-29 03:35:39 +0000
@@ -1,36 +1,33 @@
--*- org -*-
-
-* Mandos client
-** header files/symbols tally
-** check exit codes of all system calls
-** IPv4 support
-** protocol version header
-** use strsep instead of strtok?
-** change uid to nobody:nogroup
-   other drop privs stuff?
-
-* Pluginbasedclient
-** header files/symbols tally
-** check exit codes of all system calls
-** [#C] pass things in environment, like device name, etc
-   Does cryptsetup already do this?
-** use strsep instead of strtok?
-** use config file in addition to arguments
-
-* Server
-** config for:
-*** TXT record
-** protocol version header
-** Run-time communication with server
-   probably using D-Bus
-
-* Mandos-tools/utilities
-  All of this probably using D-Bus
-** List clients
-** Enable client
-** Disable client
-
-* Installer
-
-
-#+STARTUP: showall
+[Mandos client]
+configuration for OpenPGP key dir
+header files/symbols tally
+check exit codes of all system calls
+IPv4 support
+protocol version header
+use strsep instead of strtok?
+
+[Pluginbasedclient]
+disable certain plugins
+header files/symbols tally
+check exit codes of all system calls
+change uid to nobody:nogroup
+	other drop privs stuff?
+pass things in environment, like device name, etc
+	Does cryptsetup already do this?
+Configurable plugin dir
+use strsep instead of strtok?
+
+[Server]
+config for:
+	TXT record
+protocol version header
+Run-time communication with server
+	probably using D-Bus
+
+[Mandos-tools/utilities]
+	List clients
+	Enable client
+	Disable client
+
+[Installer]
+...

=== modified file 'plugbasedclient.c'
--- plugbasedclient.c	2008-08-02 18:46:45 +0000
+++ plugbasedclient.c	2008-08-01 06:33:15 +0000
@@ -21,15 +21,12 @@
  * Contact the authors at <mandos@fukt.bsnet.se>.
  */
 
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-
 #include <stdio.h>		/* popen(), fileno(), fprintf(),
 				   stderr, STDOUT_FILENO */
 #include <iso646.h>		/* and, or, not */
-#include <sys/types.h>	        /* DIR, opendir(), stat(),
-				   struct stat, waitpid(),
-				   WIFEXITED(), WEXITSTATUS(),
-				   wait() */
+#include <sys/types.h>	       /* DIR, opendir(), stat(), struct stat,
+				  waitpid(), WIFEXITED(),
+				  WEXITSTATUS(), wait() */
 #include <sys/wait.h>		/* wait() */
 #include <dirent.h>		/* DIR, struct dirent, opendir(),
 				   readdir(), closedir() */
@@ -58,9 +55,6 @@
   char *buffer;
   size_t buffer_size;
   size_t buffer_length;
-  bool eof;
-  bool completed;
-  int status;
   struct process *next;
 } process;
 
@@ -112,76 +106,24 @@
   p->argv[p->argc] = NULL;
 }
 
-/*
- * Based on the example in the GNU LibC manual chapter 13.13 "File
- * Descriptor Flags".
- * *Note File Descriptor Flags:(libc)Descriptor Flags.
- */
-int set_cloexec_flag(int fd)
-{
-  int ret = fcntl(fd, F_GETFD, 0);
-  /* If reading the flags failed, return error indication now. */
-  if(ret < 0){
-    return ret;
-  }
-  /* Store modified flag word in the descriptor. */
-  return fcntl(fd, F_SETFD, ret | FD_CLOEXEC);
-}
-
 #define BUFFER_SIZE 256
 
-const char *argp_program_version = "plugbasedclient 0.9";
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
-
-process *process_list = NULL;
-
-/* Mark a process as completed when it exits, and save its exit
-   status. */
-void handle_sigchld(__attribute__((unused)) int sig){
-  process *proc = process_list;
-  int status;
-  pid_t pid = wait(&status);
-  while(proc != NULL and proc->pid != pid){
-    proc = proc->next;
-  }
-  if(proc == NULL){
-    /* Process not found in process list */
-    return;
-  }
-  proc->status = status;
-  proc->completed = true;
-}
+const char *argp_program_version =
+  "plugbasedclient 0.9";
+const char *argp_program_bug_address =
+  "<mandos@fukt.bsnet.se>";
 
 int main(int argc, char *argv[]){
   const char *plugindir = "/conf/conf.d/mandos/plugins.d";
   size_t d_name_len;
-  DIR *dir = NULL;
+  DIR *dir;
   struct dirent *dirst;
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
-  uid_t uid = 65534;
-  gid_t gid = 65534;
+  process *process_list = NULL;
   bool debug = false;
   int exitstatus = EXIT_SUCCESS;
-  struct sigaction old_sigchld_action;
-  struct sigaction sigchld_action = { .sa_handler = handle_sigchld,
-				      .sa_flags = SA_NOCLDSTOP };
-  char *plus_options = NULL;
-  char **plus_argv = NULL;
-  
-  /* Establish a signal handler */
-  sigemptyset(&sigchld_action.sa_mask);
-  ret = sigaddset(&sigchld_action.sa_mask, SIGCHLD);
-  if(ret < 0){
-    perror("sigaddset");
-    exit(EXIT_FAILURE);
-  }
-  ret = sigaction(SIGCHLD, &sigchld_action, &old_sigchld_action);
-  if(ret < 0){
-    perror("sigaction");
-    exit(EXIT_FAILURE);
-  }
   
   /* The options we understand. */
   struct argp_option options[] = {
@@ -197,20 +139,14 @@
     { .name = "plugin-dir", .key = 128,
       .arg = "DIRECTORY",
       .doc = "Specify a different plugin directory", .group = 2 },
-    { .name = "userid", .key = 129,
-      .arg = "ID", .flags = 0,
-      .doc = "User ID the plugins will run as", .group = 2 },
-    { .name = "groupid", .key = 130,
-      .arg = "ID", .flags = 0,
-      .doc = "Group ID the plugins will run as", .group = 2 },
-    { .name = "debug", .key = 131,
+    { .name = "debug", .key = 129,
       .doc = "Debug mode", .group = 3 },
     { .name = NULL }
   };
   
   error_t parse_opt (int key, char *arg, struct argp_state *state) {
-    /* Get the INPUT argument from `argp_parse', which we know is a
-       pointer to our plugin list pointer. */
+       /* Get the INPUT argument from `argp_parse', which we
+          know is a pointer to our plugin list pointer. */
     plugin **plugins = state->input;
     switch (key) {
     case 'g':
@@ -219,19 +155,19 @@
 	do{
 	  addargument(getplugin(NULL, plugins), p);
 	  p = strtok(NULL, ",");
-	} while (p != NULL);
+	} while (p);
       }
       break;
     case 'o':
       if (arg != NULL){
 	char *name = strtok(arg, ":");
 	char *p = strtok(NULL, ":");
-	if(p != NULL){
+	if(p){
 	  p = strtok(p, ",");
 	  do{
 	    addargument(getplugin(name, plugins), p);
 	    p = strtok(NULL, ",");
-	  } while (p != NULL);
+	  } while (p);
 	}
       }
       break;
@@ -244,19 +180,10 @@
       plugindir = arg;
       break;
     case 129:
-      uid = (uid_t)strtol(arg, NULL, 10);
-      break;
-    case 130:
-      gid = (gid_t)strtol(arg, NULL, 10);
-      break;
-    case 131:
       debug = true;
       break;
     case ARGP_KEY_ARG:
-      if(plus_options != NULL or arg == NULL or arg[0] != '+'){
-	argp_usage (state);
-      }
-      plus_options = arg;
+      argp_usage (state);
       break;
     case ARGP_KEY_END:
       break;
@@ -269,82 +196,40 @@
   plugin *plugin_list = NULL;
   
   struct argp argp = { .options = options, .parser = parse_opt,
-		       .args_doc = "[+PLUS_SEPARATED_OPTIONS]",
+		       .args_doc = "",
 		       .doc = "Mandos plugin runner -- Run plugins" };
   
-  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);  
-  
-  if(plus_options){
-    /* This is a mangled argument in the form of
-     "+--option+--other-option=parameter+--yet-another-option", etc */
-    /* Make new argc and argv vars, and call argp_parse() again. */
-    plus_options++;		/* skip the first '+' character */
-    const char delims[] = "+";
-    char *arg;
-    int new_argc = 1;
-    plus_argv = malloc(sizeof(char*) * 2);
-    if(plus_argv == NULL){
-      perror("malloc");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    plus_argv[0] = argv[0];
-    plus_argv[1] = NULL;
-    arg = strtok(plus_options, delims); /* Get first argument */
-    while(arg != NULL){
-      new_argc++;
-      plus_argv = realloc(plus_argv, sizeof(char *)
-			 * ((unsigned int) new_argc + 1));
-      if(plus_argv == NULL){
-	perror("malloc");
-	exitstatus = EXIT_FAILURE;
-	goto end;
-      }
-      plus_argv[new_argc-1] = arg;
-      plus_argv[new_argc] = NULL;
-      arg = strtok(NULL, delims); /* Get next argument */
-    }
-    argp_parse (&argp, new_argc, plus_argv, 0, 0, &plugin_list);  
-  }
+  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);
   
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
-	      p->name ? p->name : "Global", p->argc - 1);
+	      p->name ? p->name : "Global", p->argc);
       for(char **a = p->argv; *a != NULL; a++){
 	fprintf(stderr, "\tArg: %s\n", *a);
       }
     }
   }
   
-  ret = setuid(uid);
-  if (ret == -1){
-    perror("setuid");
-  }
-  
-  setgid(gid);
-  if (ret == -1){
-    perror("setuid");
-  }
-  
   dir = opendir(plugindir);
+  {
+    /* Set the FD_CLOEXEC flag on the directory */
+    int fd = dirfd(dir);
+    ret = fcntl (fd, F_GETFD, 0);
+    if(ret < 0){
+      perror("fcntl F_GETFD");
+      goto end;
+    }
+    ret = fcntl(fd, F_SETFD, FD_CLOEXEC | ret);
+    if(ret < 0){
+      perror("fcntl F_SETFD");
+      goto end;
+    }
+  }
+  
   if(dir == NULL){
-    perror("Could not open plugin dir");
-    exitstatus = EXIT_FAILURE;
-    goto end;
-  }
-  
-  /* Set the FD_CLOEXEC flag on the directory, if possible */
-  {
-    int dir_fd = dirfd(dir);
-    if(dir_fd >= 0){
-      ret = set_cloexec_flag(dir_fd);
-      if(ret < 0){
-	perror("set_cloexec_flag");
-	exitstatus = EXIT_FAILURE;
-	goto end;
-      }
-    }
+    fprintf(stderr, "Can not open directory\n");
+    return EXIT_FAILURE;
   }
   
   FD_ZERO(&rfds_all);
@@ -373,7 +258,7 @@
 	if((d_name_len >= pre_len)
 	   and strncmp((dirst->d_name), *pre, pre_len) == 0){
 	  if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+	    fprintf(stderr, "Ignoring plugin dir entry name \"%s\""
 		    " with bad prefix %s\n", dirst->d_name, *pre);
 	  }
 	  bad_name = true;
@@ -391,7 +276,7 @@
 	   and (strcmp((dirst->d_name)+d_name_len-suf_len, *suf)
 		== 0)){
 	  if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+	    fprintf(stderr, "Ignoring plugin dir entry name \"%s\""
 		    " with bad suffix %s\n", dirst->d_name, *suf);
 	  }
 	  bad_name = true;
@@ -407,290 +292,159 @@
     char *filename = malloc(d_name_len + strlen(plugindir) + 2);
     if (filename == NULL){
       perror("malloc");
-      exitstatus = EXIT_FAILURE;
+      exitstatus =EXIT_FAILURE;
       goto end;
     }
-    strcpy(filename, plugindir); /* Spurious warning */
-    strcat(filename, "/");	/* Spurious warning */
-    strcat(filename, dirst->d_name); /* Spurious warning */
-    
+    strcpy(filename, plugindir);
+    strcat(filename, "/");
+    strcat(filename, dirst->d_name);    
+
     stat(filename, &st);
-    
+
     if (not S_ISREG(st.st_mode)	or (access(filename, X_OK) != 0)){
       if(debug){
-	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+	fprintf(stderr, "Ignoring plugin dir entry name \"%s\""
 		" with bad type or mode\n", filename);
       }
-      free(filename);
       continue;
     }
     if(getplugin(dirst->d_name, &plugin_list)->disabled){
       if(debug){
-	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
+	fprintf(stderr, "Ignoring disabled plugin \"%s\"",
 		dirst->d_name);
       }
-      free(filename);
       continue;
     }
-    plugin *p = getplugin(dirst->d_name, &plugin_list);
-    {
-      /* Add global arguments to argument list for this plugin */
-      plugin *g = getplugin(NULL, &plugin_list);
-      for(char **a = g->argv + 1; *a != NULL; a++){
-	addargument(p, *a);
-      }
-    }
+    // Starting a new process to be watched
     int pipefd[2]; 
     ret = pipe(pipefd);
     if (ret == -1){
-      perror("pipe");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    ret = set_cloexec_flag(pipefd[0]);
-    if(ret < 0){
-      perror("set_cloexec_flag");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    ret = set_cloexec_flag(pipefd[1]);
-    if(ret < 0){
-      perror("set_cloexec_flag");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    /* Block SIGCHLD until process is safely in process list */
-    ret = sigprocmask (SIG_BLOCK, &sigchld_action.sa_mask, NULL);
-    if(ret < 0){
-      perror("sigprocmask");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    // Starting a new process to be watched
+      perror(argv[0]);
+      goto end;
+    }
     pid_t pid = fork();
     if(pid == 0){
       /* this is the child process */
-      ret = sigaction(SIGCHLD, &old_sigchld_action, NULL);
-      if(ret < 0){
-	perror("sigaction");
-	_exit(EXIT_FAILURE);
-      }
-      ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
-      if(ret < 0){
-	perror("sigprocmask");
-	_exit(EXIT_FAILURE);
-      }
+      closedir(dir);
+      close(pipefd[0]);	/* close unused read end of pipe */
       dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
       
-      if(dirfd(dir) < 0){
-	/* If dir has no file descriptor, we could not set FD_CLOEXEC
-	   above and must now close it manually here. */
-	closedir(dir);
+      plugin *p = getplugin(dirst->d_name, &plugin_list);
+      plugin *g = getplugin(NULL, &plugin_list);
+      for(char **a = g->argv + 1; *a != NULL; a++){
+	addargument(p, *a);
       }
       if(execv(filename, p->argv) < 0){
-	perror("execv");
+	perror(argv[0]);
+	close(pipefd[1]);
 	_exit(EXIT_FAILURE);
       }
       /* no return */
     }
-    /* parent process */
-    free(filename);
     close(pipefd[1]);		/* close unused write end of pipe */
     process *new_process = malloc(sizeof(process));
     if (new_process == NULL){
       perror("malloc");
-      ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
-      if(ret < 0){
-	perror("sigprocmask");
-      }
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    
-    *new_process = (struct process){ .pid = pid,
-				     .fd = pipefd[0],
-				     .next = process_list };
-    // List handling
-    process_list = new_process;
-    /* Unblock SIGCHLD so signal handler can be run if this process
-       has already completed */
-    ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
-    if(ret < 0){
-      perror("sigprocmask");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    
+      exitstatus = EXIT_FAILURE;
+      goto end;
+    }
+    
+    new_process->fd = pipefd[0];
+    new_process->buffer = malloc(BUFFER_SIZE);
+    if (new_process->buffer == NULL){
+      perror("malloc");
+      exitstatus = EXIT_FAILURE;
+      goto end;
+    }
+    new_process->buffer_size = BUFFER_SIZE;
+    new_process->buffer_length = 0;
     FD_SET(new_process->fd, &rfds_all);
-    
+      
     if (maxfd < new_process->fd){
       maxfd = new_process->fd;
     }
     
-  }
-  
-  /* Free the plugin list */
-  for(plugin *next; plugin_list != NULL; plugin_list = next){
-    next = plugin_list->next;
-    free(plugin_list->argv);
-    free(plugin_list);
+    //List handling
+    new_process->next = process_list;
+    process_list = new_process;
   }
   
   closedir(dir);
-  dir = NULL;
   
-  if (process_list == NULL){
-    fprintf(stderr, "No plugin processes started, exiting\n");
-    exitstatus = EXIT_FAILURE;
-    goto end;
-  }
-  while(process_list){
-    fd_set rfds = rfds_all;
-    int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
-    if (select_ret == -1){
-      perror("select");
-      exitstatus = EXIT_FAILURE;
-      goto end;
-    }
-    /* OK, now either a process completed, or something can be read
-       from one of them */
-    for(process *proc = process_list; proc ; proc = proc->next){
-      /* Is this process completely done? */
-      if(proc->eof and proc->completed){
-	/* Only accept the plugin output if it exited cleanly */
-	if(not WIFEXITED(proc->status)
-	   or WEXITSTATUS(proc->status) != 0){
-	  /* Bad exit by plugin */
-	  if(debug){
-	    if(WIFEXITED(proc->status)){
-	      fprintf(stderr, "Plugin %d exited with status %d\n",
-		      proc->pid, WEXITSTATUS(proc->status));
-	    } else if(WIFSIGNALED(proc->status)) {
-	      fprintf(stderr, "Plugin %d killed by signal %d\n",
-		      proc->pid, WTERMSIG(proc->status));
-	    } else if(WCOREDUMP(proc->status)){
-	      fprintf(stderr, "Plugin %d dumped core\n", proc->pid);
-	    }
-	  }
-	  /* Remove the plugin */
-	  FD_CLR(proc->fd, &rfds_all);
-	  /* Block signal while modifying process_list */
-	  ret = sigprocmask (SIG_BLOCK, &sigchld_action.sa_mask, NULL);
-	  if(ret < 0){
-	    perror("sigprocmask");
-	    exitstatus = EXIT_FAILURE;
-	    goto end;
-	  }
-	  /* Delete this process entry from the list */
-	  if(process_list == proc){
-	    /* First one - simple */
-	    process_list = proc->next;
-	  } else {
-	    /* Second one or later */
-	    for(process *p = process_list; p != NULL; p = p->next){
-	      if(p->next == proc){
-		p->next = proc->next;
-		break;
+  if (process_list != NULL){
+    while(true){
+      fd_set rfds = rfds_all;
+      int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
+      if (select_ret == -1){
+	perror(argv[0]);
+	goto end;
+      }else{	
+	for(process *process_itr = process_list; process_itr != NULL;
+	    process_itr = process_itr->next){
+	  if(FD_ISSET(process_itr->fd, &rfds)){
+	    if(process_itr->buffer_length + BUFFER_SIZE
+	       > process_itr->buffer_size){
+		process_itr->buffer = realloc(process_itr->buffer,
+					      process_itr->buffer_size
+					      + (size_t) BUFFER_SIZE);
+		if (process_itr->buffer == NULL){
+		  perror(argv[0]);
+		  goto end;
+		}
+		process_itr->buffer_size += BUFFER_SIZE;
+	    }
+	    ret = read(process_itr->fd, process_itr->buffer
+		       + process_itr->buffer_length, BUFFER_SIZE);
+	    if(ret < 0){
+	      /* Read error from this process; ignore it */
+	      continue;
+	    }
+	    process_itr->buffer_length += (size_t) ret;
+	    if(ret == 0){
+	      /* got EOF */
+	      /* wait for process exit */
+	      int status;
+	      waitpid(process_itr->pid, &status, 0);
+	      if(WIFEXITED(status) and WEXITSTATUS(status) == 0){
+		for(size_t written = 0;
+		    written < process_itr->buffer_length;){
+		  ret = write(STDOUT_FILENO,
+			      process_itr->buffer + written,
+			      process_itr->buffer_length - written);
+		  if(ret < 0){
+		    perror(argv[0]);
+		    goto end;
+		  }
+		  written += (size_t)ret;
+		}
+		goto end;
+	      } else {
+		FD_CLR(process_itr->fd, &rfds_all);
 	      }
 	    }
 	  }
-	  /* We are done modifying process list, so unblock signal */
-	  ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask,
-			     NULL);
-	  if(ret < 0){
-	    perror("sigprocmask");
-	  }
-	  free(proc->buffer);
-	  free(proc);
-	  /* We deleted this process from the list, so we can't go
-	     proc->next.  Therefore, start over from the beginning of
-	     the process list */
-	  break;
-	}
-	/* This process exited nicely, so print its buffer */
-	for(size_t written = 0; written < proc->buffer_length;
-	    written += (size_t)ret){
-	  ret = TEMP_FAILURE_RETRY(write(STDOUT_FILENO,
-					 proc->buffer + written,
-					 proc->buffer_length
-					 - written));
-	  if(ret < 0){
-	    perror("write");
-	    exitstatus = EXIT_FAILURE;
-	    goto end;
-	  }
-	}
-	goto end;
-      }
-      /* This process has not completed.  Does it have any output? */
-      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){
-	/* This process had nothing to say at this time */
-	continue;
-      }
-      /* Before reading, make the process' data buffer large enough */
-      if(proc->buffer_length + BUFFER_SIZE > proc->buffer_size){
-	proc->buffer = realloc(proc->buffer, proc->buffer_size
-			       + (size_t) BUFFER_SIZE);
-	if (proc->buffer == NULL){
-	  perror("malloc");
-	  exitstatus = EXIT_FAILURE;
-	  goto end;
-	}
-	proc->buffer_size += BUFFER_SIZE;
-      }
-      /* Read from the process */
-      ret = read(proc->fd, proc->buffer + proc->buffer_length,
-		 BUFFER_SIZE);
-      if(ret < 0){
-	/* Read error from this process; ignore the error */
-	continue;
-      }
-      if(ret == 0){
-	/* got EOF */
-	proc->eof = true;
-      } else {
-	proc->buffer_length += (size_t) ret;
+	}
       }
     }
   }
-  if(process_list == NULL){
-    fprintf(stderr, "All plugin processes failed, exiting\n");
-    exitstatus = EXIT_FAILURE;
-  }
   
  end:
-  /* Restore old signal handler */
-  sigaction(SIGCHLD, &old_sigchld_action, NULL);
-  
-  free(plus_argv);
-  
-  /* Free the plugin list */
-  for(plugin *next; plugin_list != NULL; plugin_list = next){
-    next = plugin_list->next;
-    free(plugin_list->argv);
-    free(plugin_list);
-  }
-  
-  if(dir != NULL){
-    closedir(dir);
-  }
-  
-  /* Free the process list and kill the processes */
-  for(process *next; process_list != NULL; process_list = next){
-    next = process_list->next;
-    close(process_list->fd);
-    kill(process_list->pid, SIGTERM);
-    free(process_list->buffer);
-    free(process_list);
-  }
-  
-  /* Wait for any remaining child processes to terminate */
-  do{
-    ret = wait(NULL);
-  } while(ret >= 0);
-  if(errno != ECHILD){
-    perror("wait");
-  }
-  
+  for(process *process_itr = process_list; process_itr != NULL;
+      process_itr = process_itr->next){
+    close(process_itr->fd);
+    kill(process_itr->pid, SIGTERM);
+    free(process_itr->buffer);
+  }
+  
+  while(true){
+    int status;
+    ret = wait(&status);
+    if (ret == -1){
+      if(errno != ECHILD){
+	perror("wait");
+      }
+      break;
+    }
+  }  
   return exitstatus;
 }

=== modified file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-08-02 21:06:29 +0000
+++ plugins.d/mandosclient.c	2008-08-01 06:33:15 +0000
@@ -37,8 +37,6 @@
 #include <stdlib.h>
 #include <time.h>
 #include <net/if.h>		/* if_nametoindex */
-#include <sys/ioctl.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
-#include <net/if.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
 
 #include <avahi-core/core.h>
 #include <avahi-core/lookup.h>
@@ -71,23 +69,21 @@
 #define BUFFER_SIZE 256
 #define DH_BITS 1024
 
-static const char *certdir = "/conf/conf.d/mandos";
-static const char *certfile = "openpgp-client.txt";
-static const char *certkey = "openpgp-client-key.txt";
+const char *certdir = "/conf/conf.d/cryptkeyreq/";
+const char *certfile = "openpgp-client.txt";
+const char *certkey = "openpgp-client-key.txt";
 
 bool debug = false;
 
 typedef struct {
-  AvahiSimplePoll *simple_poll;
-  AvahiServer *server;
+  gnutls_session_t session;
   gnutls_certificate_credentials_t cred;
-  unsigned int dh_bits;
-  const char *priority;
-} mandos_context;
-
-static ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
-				   char **new_packet,
-				   const char *homedir){
+  gnutls_dh_params_t dh_params;
+} encrypted_session;
+
+
+ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
+			    char **new_packet, const char *homedir){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_ctx_t ctx;
   gpgme_error_t rc;
@@ -249,12 +245,12 @@
   return ret;
 }
 
-static void debuggnutls(__attribute__((unused)) int level,
-			const char* string){
+void debuggnutls(__attribute__((unused)) int level,
+		 const char* string){
   fprintf(stderr, "%s", string);
 }
 
-static int initgnutls(mandos_context *mc){
+int initgnutls(encrypted_session *es){
   const char *err;
   int ret;
   
@@ -323,7 +319,7 @@
 	    safer_gnutls_strerror(ret));
   }
   
-  if ((ret = gnutls_priority_set_direct (es->session, mc->priority, &err))
+  if ((ret = gnutls_priority_set_direct (es->session, "NORMAL", &err))
       != GNUTLS_E_SUCCESS) {
     fprintf(stderr, "Syntax error at: %s\n", err);
     fprintf(stderr, "GnuTLS error: %s\n",
@@ -348,12 +344,11 @@
   return 0;
 }
 
-static void empty_log(__attribute__((unused)) AvahiLogLevel level,
-		      __attribute__((unused)) const char *txt){}
+void empty_log(__attribute__((unused)) AvahiLogLevel level,
+	       __attribute__((unused)) const char *txt){}
 
-static int start_mandos_communication(const char *ip, uint16_t port,
-				      AvahiIfIndex if_index,
-				      mandos_context *mc){
+int start_mandos_communication(const char *ip, uint16_t port,
+			       AvahiIfIndex if_index){
   int ret, tcp_sd;
   struct sockaddr_in6 to;
   encrypted_session es;
@@ -376,15 +371,15 @@
     perror("socket");
     return -1;
   }
-
+  
+  if(if_indextoname((unsigned int)if_index, interface) == NULL){
+    if(debug){
+      perror("if_indextoname");
+    }
+    return -1;
+  }
+  
   if(debug){
-    if(if_indextoname((unsigned int)if_index, interface) == NULL){
-      if(debug){
-	perror("if_indextoname");
-      }
-      return -1;
-    }
-    
     fprintf(stderr, "Binding to interface %s\n", interface);
   }
   
@@ -535,20 +530,24 @@
   return retval;
 }
 
-static void resolve_callback( AvahiSServiceResolver *r,
-			      AvahiIfIndex interface,
-			      AVAHI_GCC_UNUSED AvahiProtocol protocol,
-			      AvahiResolverEvent event,
-			      const char *name,
-			      const char *type,
-			      const char *domain,
-			      const char *host_name,
-			      const AvahiAddress *address,
-			      uint16_t port,
-			      AVAHI_GCC_UNUSED AvahiStringList *txt,
-			      AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
-			      AVAHI_GCC_UNUSED void* userdata) {
-  mandos_context *mc = userdata;
+static AvahiSimplePoll *simple_poll = NULL;
+static AvahiServer *server = NULL;
+
+static void resolve_callback(
+    AvahiSServiceResolver *r,
+    AvahiIfIndex interface,
+    AVAHI_GCC_UNUSED AvahiProtocol protocol,
+    AvahiResolverEvent event,
+    const char *name,
+    const char *type,
+    const char *domain,
+    const char *host_name,
+    const AvahiAddress *address,
+    uint16_t port,
+    AVAHI_GCC_UNUSED AvahiStringList *txt,
+    AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
+    AVAHI_GCC_UNUSED void* userdata) {
+    
   assert(r);			/* Spurious warning */
   
   /* Called whenever a service has been resolved successfully or
@@ -559,7 +558,7 @@
   case AVAHI_RESOLVER_FAILURE:
     fprintf(stderr, "(Resolver) Failed to resolve service '%s' of"
 	    " type '%s' in domain '%s': %s\n", name, type, domain,
-	    avahi_strerror(avahi_server_errno(mc->server)));
+	    avahi_strerror(avahi_server_errno(server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -570,7 +569,7 @@
 	fprintf(stderr, "Mandos server \"%s\" found on %s (%s) on"
 		" port %d\n", name, host_name, ip, port);
       }
-      int ret = start_mandos_communication(ip, port, interface, mc);
+      int ret = start_mandos_communication(ip, port, interface);
       if (ret == 0){
 	exit(EXIT_SUCCESS);
       }
@@ -579,70 +578,68 @@
   avahi_s_service_resolver_free(r);
 }
 
-static void browse_callback( AvahiSServiceBrowser *b,
-			     AvahiIfIndex interface,
-			     AvahiProtocol protocol,
-			     AvahiBrowserEvent event,
-			     const char *name,
-			     const char *type,
-			     const char *domain,
-			     AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
-			     void* userdata) {
-  mandos_context *mc = userdata;
-  assert(b);			/* Spurious warning */
-  
-  /* Called whenever a new services becomes available on the LAN or
-     is removed from the LAN */
-  
-  switch (event) {
-  default:
-  case AVAHI_BROWSER_FAILURE:
-      
-    fprintf(stderr, "(Browser) %s\n",
-	    avahi_strerror(avahi_server_errno(mc->server)));
-    avahi_simple_poll_quit(mc->simple_poll);
-    return;
-      
-  case AVAHI_BROWSER_NEW:
-    /* We ignore the returned resolver object. In the callback
-       function we free it. If the server is terminated before
-       the callback function is called the server will free
-       the resolver for us. */
-      
-    if (!(avahi_s_service_resolver_new(mc->server, interface, protocol, name,
-				       type, domain,
-				       AVAHI_PROTO_INET6, 0,
-				       resolve_callback, mc)))
-      fprintf(stderr, "Failed to resolve service '%s': %s\n", name,
-	      avahi_strerror(avahi_server_errno(s)));
-    break;
-      
-  case AVAHI_BROWSER_REMOVE:
-    break;
-      
-  case AVAHI_BROWSER_ALL_FOR_NOW:
-  case AVAHI_BROWSER_CACHE_EXHAUSTED:
-    break;
-  }
+static void browse_callback(
+    AvahiSServiceBrowser *b,
+    AvahiIfIndex interface,
+    AvahiProtocol protocol,
+    AvahiBrowserEvent event,
+    const char *name,
+    const char *type,
+    const char *domain,
+    AVAHI_GCC_UNUSED AvahiLookupResultFlags flags,
+    void* userdata) {
+    
+    AvahiServer *s = userdata;
+    assert(b);			/* Spurious warning */
+    
+    /* Called whenever a new services becomes available on the LAN or
+       is removed from the LAN */
+    
+    switch (event) {
+    default:
+    case AVAHI_BROWSER_FAILURE:
+      
+      fprintf(stderr, "(Browser) %s\n",
+	      avahi_strerror(avahi_server_errno(server)));
+      avahi_simple_poll_quit(simple_poll);
+      return;
+      
+    case AVAHI_BROWSER_NEW:
+      /* We ignore the returned resolver object. In the callback
+	 function we free it. If the server is terminated before
+	 the callback function is called the server will free
+	 the resolver for us. */
+      
+      if (!(avahi_s_service_resolver_new(s, interface, protocol, name,
+					 type, domain,
+					 AVAHI_PROTO_INET6, 0,
+					 resolve_callback, s)))
+	fprintf(stderr, "Failed to resolve service '%s': %s\n", name,
+		avahi_strerror(avahi_server_errno(s)));
+      break;
+      
+    case AVAHI_BROWSER_REMOVE:
+      break;
+      
+    case AVAHI_BROWSER_ALL_FOR_NOW:
+    case AVAHI_BROWSER_CACHE_EXHAUSTED:
+      break;
+    }
 }
 
-/* Combines file name and path and returns the malloced new
-   string. some sane checks could/should be added */
-static const char *combinepath(const char *first, const char *second){
-  size_t f_len = strlen(first);
-  size_t s_len = strlen(second);
-  char *tmp = malloc(f_len + s_len + 2);
+/* combinds file name and path and returns the malloced new string. som sane checks could/should be added */
+const char *combinepath(const char *first, const char *second){
+  char *tmp;
+  tmp = malloc(strlen(first) + strlen(second) + 2);
   if (tmp == NULL){
+    perror("malloc");
     return NULL;
   }
-  if(f_len > 0){
-    memcpy(tmp, first, f_len);
-  }
-  tmp[f_len] = '/';
-  if(s_len > 0){
-    memcpy(tmp + f_len + 1, second, s_len);
-  }
-  tmp[f_len + 1 + s_len] = '\0';
+  strcpy(tmp, first);
+  if (first[0] != '\0' and first[strlen(first) - 1] != '/'){
+    strcat(tmp, "/");
+  }
+  strcat(tmp, second);
   return tmp;
 }
 
@@ -653,13 +650,9 @@
     int error;
     int ret;
     int returncode = EXIT_SUCCESS;
-    const char *interface = "eth0";
-    struct ifreq network;
-    int sd;
+    const char *interface = NULL;
+    AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
     char *connect_to = NULL;
-    AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
-    mandos_context mc = { .simple_poll = NULL, .server = NULL,
-			  .dh_bits = 2048, .priority = "SECURE256"};
     
     while (true){
       static struct option long_options[] = {
@@ -669,8 +662,6 @@
 	{"certdir", required_argument, 0, 'd'},
 	{"certkey", required_argument, 0, 'c'},
 	{"certfile", required_argument, 0, 'k'},
-	{"dh_bits", required_argument, 0, 'D'},
-	{"priority", required_argument, 0, 'p'},
 	{0, 0, 0, 0} };
       
       int option_index = 0;
@@ -699,44 +690,22 @@
       case 'k':
 	certkey = optarg;
 	break;
-      case 'D':
-	{
-	  long int tmp;
-	  errno = 0;
-	  tmp = strtol(optarg, NULL, 10);
-	  if (errno == ERANGE){
-	    perror("strtol");
-	    exit(EXIT_FAILURE);
-	  }
-	  mc.dh_bits = tmp;
-	}
-	break;
-      case 'p':
-	mc.priority = optarg;
-	break;
       default:
 	exit(EXIT_FAILURE);
       }
     }
-    
+
     certfile = combinepath(certdir, certfile);
     if (certfile == NULL){
-      perror("combinepath");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-
-    certkey = combinepath(certdir, certkey);
-    if (certkey == NULL){
-      perror("combinepath");
-      returncode = EXIT_FAILURE;
       goto exit;
     }
     
-    if_index = (AvahiIfIndex) if_nametoindex(interface);
-    if(if_index == 0){
-      fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exit(EXIT_FAILURE);
+    if(interface != NULL){
+      if_index = (AvahiIfIndex) if_nametoindex(interface);
+      if(if_index == 0){
+	fprintf(stderr, "No such interface: \"%s\"\n", interface);
+	exit(EXIT_FAILURE);
+      }
     }
     
     if(connect_to != NULL){
@@ -763,30 +732,10 @@
       }
     }
     
-    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd < 0) {
-      perror("socket");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    strcpy(network.ifr_name, interface);    
-    ret = ioctl(sd, SIOCGIFFLAGS, &network);
-    if(ret == -1){
-      
-      perror("ioctl SIOCGIFFLAGS");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    if((network.ifr_flags & IFF_UP) == 0){
-      network.ifr_flags |= IFF_UP;
-      ret = ioctl(sd, SIOCSIFFLAGS, &network);
-      if(ret == -1){
-	perror("ioctl SIOCSIFFLAGS");
-	returncode = EXIT_FAILURE;
-	goto exit;
-      }
-    }
-    close(sd);
+    certkey = combinepath(certdir, certkey);
+    if (certkey == NULL){
+      goto exit;
+    }
     
     if (not debug){
       avahi_set_log_function(empty_log);
@@ -796,9 +745,9 @@
     srand((unsigned int) time(NULL));
 
     /* Allocate main loop object */
-    if (!(mc.simple_poll = avahi_simple_poll_new())) {
+    if (!(simple_poll = avahi_simple_poll_new())) {
         fprintf(stderr, "Failed to create simple poll object.\n");
-	returncode = EXIT_FAILURE;	
+	
         goto exit;
     }
 
@@ -810,14 +759,14 @@
     config.publish_domain = 0;
 
     /* Allocate a new server */
-    mc.server = avahi_server_new(avahi_simple_poll_get(simple_poll),
+    server = avahi_server_new(avahi_simple_poll_get(simple_poll),
 			      &config, NULL, NULL, &error);
 
     /* Free the configuration data */
     avahi_server_config_free(&config);
 
     /* Check if creating the server object succeeded */
-    if (!mc.server) {
+    if (!server) {
         fprintf(stderr, "Failed to create server: %s\n",
 		avahi_strerror(error));
 	returncode = EXIT_FAILURE;
@@ -825,13 +774,13 @@
     }
     
     /* Create the service browser */
-    sb = avahi_s_service_browser_new(mc.server, if_index,
+    sb = avahi_s_service_browser_new(server, if_index,
 				     AVAHI_PROTO_INET6,
 				     "_mandos._tcp", NULL, 0,
-				     browse_callback, &mc);
+				     browse_callback, server);
     if (!sb) {
         fprintf(stderr, "Failed to create service browser: %s\n",
-		avahi_strerror(avahi_server_errno(mc.server)));
+		avahi_strerror(avahi_server_errno(server)));
 	returncode = EXIT_FAILURE;
         goto exit;
     }
@@ -854,8 +803,8 @@
     if (sb)
         avahi_s_service_browser_free(sb);
     
-    if (mc.server)
-        avahi_server_free(mc.server);
+    if (server)
+        avahi_server_free(server);
 
     if (simple_poll)
         avahi_simple_poll_free(simple_poll);

=== modified file 'plugins.d/passprompt.c'
--- plugins.d/passprompt.c	2008-08-02 10:48:24 +0000
+++ plugins.d/passprompt.c	2008-07-29 03:35:39 +0000
@@ -102,11 +102,15 @@
   
   sigemptyset(&new_action.sa_mask);
   sigaddset(&new_action.sa_mask, SIGINT);
+  sigaddset(&new_action.sa_mask, SIGQUIT);
   sigaddset(&new_action.sa_mask, SIGHUP);
   sigaddset(&new_action.sa_mask, SIGTERM);
   sigaction(SIGINT, NULL, &old_action);
   if (old_action.sa_handler != SIG_IGN)
     sigaction(SIGINT, &new_action, NULL);
+  sigaction(SIGQUIT, NULL, &old_action);
+  if (old_action.sa_handler != SIG_IGN)
+    sigaction(SIGQUIT, &new_action, NULL);
   sigaction(SIGHUP, NULL, &old_action);
   if (old_action.sa_handler != SIG_IGN)
     sigaction(SIGHUP, &new_action, NULL);

